# frozen_string_literal: true

module Helpers
  # Screenshot helper
  module Screenshot
    def resize_window(width, height)
      Capybara.page.driver.browser.manage.window.resize_to(width, height)
    end

    def fullpage_height
      Capybara.page.evaluate_script(%(document.documentElement.offsetHeight + 100;))
    end

    def fullpage
      size = Capybara.page.current_window.size
      resize_window(size[0], fullpage_height)
    end

    def fullpage_screenshot(filename)
      size = Capybara.page.current_window.size
      resize_window(size[0], fullpage_height)
      screenshot(filename)
      resize_window(size[0], size[1])
    end

    def screenshot(filename)
      Capybara.page.save_screenshot(filename)
    end
  end
end
