# frozen_string_literal: true

require_rel 'results'

module ImageDiff
  # Diff YAML files
  module Differ
    # TODO: Move this code smell
    def reference_file
      path_and_filename.sub(%r{^[^/]*}, 'reference')
    end

    # Diff class
    class Diff
      include Differ::Results

      attr_reader :snapshot

      def initialize(snapshot)
        @snapshot = snapshot
        result
      end

      def reference
        @reference ||= @snapshot.reference_file
      end
    end

    # Singleton to store differences
    class Differences
      extend Forwardable
      include Singleton

      def_delegators :@list, :map

      def initialize(list = {})
        @list = list
      end

      def []=(key, str)
        @list[key] = str unless str.chomp.empty?
      end

      # TODO: output failures separately from reference file misses
      #       also produce screenshot on failure
      def self.result
        instance.map { |diff| puts(*diff) }
      end
    end
  end
end
