# frozen_string_literal: true

require 'open3'

module ImageDiff
  module Differ
    # ImageMagick compare interface
    module ImageMagick
      CMD = 'compare -metric rmse '

      module_function

      def absolute_error(args)
        Open3.popen2e(CMD + args) do |_stdin, stdout_stderr, wait_thr|
          [wait_thr.value.exitstatus, stdout_stderr.readlines.join("\n")]
        end
      end
    end
  end
end
