# frozen_string_literal: true

require_rel 'snapshot'

module ImageDiff
  # Screenshot class
  class PNGSnapshot < Snapshot
    include Helpers::Screenshot

    @id = 'PNG'

    class << self
      attr_reader :master_screenshot_path
    end

    def extension
      '.png'
    end

    def write
      fullpage_screenshot(path_and_filename)
    end

    def compare
      write
      ImageDiff.new(self)
    end
  end
end
