# frozen_string_literal: true

require_rel 'writer'
require_rel 'differ'

module ImageDiff
  # Snapshot class
  class Snapshot
    include Writer
    include Differ

    class << self
      attr_reader :id
    end

    attr_reader :snapshot_path, :file

    def initialize(snapshot_path, file)
      @snapshot_path = snapshot_path
      @file = file
    end

    def fullpath
      FileUtils.mkdir_p(snapshot_path)
    end

    def filepath
      File.join(fullpath, @file)
    end

    def filename
      "#{@file}#{extension}"
    end
  end
end
